require "util"
require "story"
require "defines"

global.gameTime = 0
global.storyProgress = 0
global.carParts = 0
global.repair1 = false
global.repair2 = false
global.repair3 = false
global.repair4 = false
global.repairMessage = false

script.on_event(defines.events.on_player_created, function(event)
    local character = game.get_player(event.player_index)
	character.insert{name = "submachine-gun", count = 1}
	character.insert{name = "piercing-bullet-magazine", count = 10}
	character.insert{name = "steel-axe", count = 1}
    local recipe_list = game.player.force.recipes
	game.create_force('remnentForce')
	game.create_force('remnentForceBase')
	game.create_force('lootable')
	game.forces['remnentForce'].set_cease_fire('lootable', true)
	game.forces['remnentForceBase'].set_cease_fire('lootable', true)
	game.forces['player'].set_cease_fire('lootable', true)
	game.forces['lootable'].set_cease_fire('player', true)
	game.get_entity_by_tag("base1acum").energy = 100000000
	game.get_entity_by_tag("base1acum2").energy = 100000000
	game.get_entity_by_tag("base1acum3").energy = 100000000
	game.get_entity_by_tag("base1acum4").energy = 100000000
	convertMapEntities()
	game.show_message_dialog{text = {"welcome"}}
	game.players[1].gui.top.add{type = "frame", caption = "Objectives", name = "MainFrame", direction = "vertical"} 
	game.players[1].gui.top.MainFrame.add{type = "label", caption = "Investigate the nearby structure"}
end)

script.on_event(defines.events.on_tick, function(event)
    global.gameTime = global.gameTime + 1;
	storyHandler()
    if global.gameTime % 10 == 0 then
		local chestEntities = game.get_surface(1).find_entities_filtered{area = {{-1000, -1000}, {1000, 1000}}, force= "lootable"}
		Count = 0
		for Index, Value in pairs( chestEntities ) do
			Count = Count + 1
		end
		for i=Count,1,-1 do
			entity = chestEntities[i]
			if(game.player.can_reach_entity(entity)) then
			entity.force = game.forces['player']
		end
		end
	end
end)

function storyHandler()
	if(game.player.can_reach_entity(game.get_entity_by_tag("closeTurret")))then
		if global.storyProgress == 0 then
			storyUpdate(global.storyProgress)
		end
	end
	if(game.player.can_reach_entity(game.get_entity_by_tag("lootChest")))then
		if global.storyProgress == 1 then
			storyUpdate(global.storyProgress)
		end
	end
	if(game.player.position.y < 90)then
		if global.storyProgress == 2 then
			storyUpdate(global.storyProgress)
		end
	end
	if game.get_entity_by_tag("damagedCar") ~= nil then
	if(game.player.can_reach_entity(game.get_entity_by_tag("damagedCar")))then
		if global.storyProgress == 3 then
			storyUpdate(global.storyProgress)
		end
	end
	if global.storyProgress == 4 then
		if global.carParts == 4 then
			storyUpdate(global.storyProgress)
			game.get_entity_by_tag("damagedCar").force = game.forces['player']
			carX = game.get_entity_by_tag("damagedCar").position.x
			carY = game.get_entity_by_tag("damagedCar").position.y
			game.get_entity_by_tag("damagedCar").destroy()
			game.get_surface(1).create_entity{name = "car", position = {carX, carY}, force=game.player.force}
			game.player.insert{name = "coal", count = 50}
		end
	end
	end
	if global.storyProgress == 4 then
	if(game.player.can_reach_entity(game.get_entity_by_tag("repairChest1")))then
		if global.repair1 == false then
			global.repair1 = true
			global.carParts = global.carParts + 1
			game.player.print("You found a car part in the green chest!")
		end
	end
	if(game.player.can_reach_entity(game.get_entity_by_tag("repairChest2")))then
		if global.repair2 == false then
			global.repair2 = true
			global.carParts = global.carParts + 1
			game.player.print("You found a car part in the green chest!")
		end
	end
	if(game.player.can_reach_entity(game.get_entity_by_tag("repairChest3")))then
		if global.repair3 == false then
			global.repair3 = true
			global.carParts = global.carParts + 1
			game.player.print("You found a car part in the green chest!")
		end
	end
	if(game.player.can_reach_entity(game.get_entity_by_tag("repairChest4")))then
		if global.repair4 == false then
			global.repair4 = true
			global.carParts = global.carParts + 1
			game.player.print("You found a car part in the green chest!")
			end
		end
    end
	if global.carParts == 4 then
		if global.repairMessage == false then
			global.repairMessage = true
			updateDisplay("Get back to the car and repair it!")
		end
	end
end

function storyUpdate(storyProgress)
    global.storyProgress = global.storyProgress + 1
	if (storyProgress == 0) then
		updateDisplay("I need to disable these turrets! It looks like there is loot in there to!")
    end
	if (storyProgress == 1) then
		updateDisplay("I should follow this road and see where it leads..")
    end
	if (storyProgress == 2) then
		updateDisplay("There might be something useful here.. Explore the area.")
    end
	if (storyProgress == 3) then
		updateDisplay("Search for parts to repair the damaged car by the refineries.")
    end
	if (storyProgress == 4) then
		updateDisplay("The car has been repaired! V0.1 Ending Reached")
    end
	game.player.print("Story Update")
end

function convertMapEntities()
local entity = nil
local entities = game.get_surface(1).find_entities_filtered{area = {{-1000, -1000}, {1000, 1000}}, force= "player"}
local enemies = game.get_surface(1).find_entities_filtered{area = {{-1000, -1000}, {1000, 1000}}, force= "enemy"}
for _,v in ipairs(enemies) do 
    table.insert(entities, v)
end
Count = 0;
for Index, Value in pairs( entities ) do
	Count = Count + 1
end
for i=Count,1,-1 
    do
    entity = entities[i]
	entityX = entity.position.x
	entityY = entity.position.y
	    if(entityX >= 265 and entityX <= 408 and entityY >= -10 and entityY <= 90) then
			if entity.name ~= "steel-chest" then
				entity.force = game.forces['remnentForceBase']
			else
				entity.force = game.forces['lootable']
			end
	    end
	    if(entityX >= 333 and entityX <= 375 and entityY >= 130 and entityY <= 160) then
			if entity.name ~= "steel-chest" then
				entity.force = game.forces['remnentForceBase']
			else
				entity.force = game.forces['lootable']
			end
	    end
    end
    --local enemies = game.get_surface(1).find_entities_filtered{area = {{-1000, -1000}, {1000, 1000}}, force= "remnentForce"}
    --game.player.print(enemies[1].position.x)
end
function updateDisplay(message)
    game.players[1].gui.top.MainFrame.destroy()
	game.players[1].gui.top.add{type = "frame", caption = "Objectives", name = "MainFrame", direction = "vertical"} 
	game.players[1].gui.top.MainFrame.add{type = "label", caption = message}
end
function distanceFrom(x1,y1,x2,y2) return math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2) end
